<?php
/**
 * app/plugins/chat/plugin.php
 *
 * This houses all of the main plugin info and functionality.
 *
 * @package TP Chat
 * @version 3.0
 * @author  Joey Kimsey <Joey@thetempusproject.com>
 * @link    https://TheTempusProject.com
 * @license https://opensource.org/licenses/MIT [MIT LICENSE]
 */
namespace TheTempusProject\Plugins;

use TheTempusProject\Classes\Plugin;
use TheTempusProject\TheTempusProject as App;

class Chat extends Plugin {
    public $pluginName = 'TP Chat';
    public $configName = 'chat';
    public $pluginAuthor = 'JoeyK';
    public $pluginWebsite = 'https://TheTempusProject.com';
    public $modelVersion = '1.0';
    public $pluginVersion = '3.0';
    public $pluginDescription = 'A simple plugin which adds a site wide chat system.';
    public $permissionMatrix = [
        'chat' => [
            'pretty' => 'Can use chat',
            'default' => false,
        ],
    ];
    public $admin_links = [
        [
            'text' => '<i class="fa fa-fw fa-copy"></i> Chat',
            'url' => '{ROOT_URL}admin/chat',
        ],
    ];
    public $main_links = [
        [
            'text' => 'Chat',
            'url' => '{ROOT_URL}chat/index',
            'filter' => 'loggedin',
        ],
    ];
    public $configMatrix = [
        'enabled' => [
            'type' => 'radio',
            'pretty' => 'Enable Chat.',
            'default' => true,
        ],
    ];
    public function __construct( $load = false ) {
        parent::__construct( $load );
    }
}