<?php
/**
 * app/plugins/charactercreator/controllers/creator.php
 *
 * This is the Character Creation controller.
 *
 * @package TTE Dungeons & Dragons
 * @version 3.0
 * @author  Joey Kimsey <Joey@thetempusproject.com>
 * @link    https://TheTempusProject.com
 * @license https://opensource.org/licenses/MIT [MIT LICENSE]
 */
namespace TheTempusProject\Controllers;

use TheTempusProject\Houdini\Classes\Views;
use TheTempusProject\Classes\Controller;
use TheTempusProject\Models\Classes;
use TheTempusProject\Models\Items;
use TheTempusProject\Models\Monsters;
use TheTempusProject\Models\Races;
use TheTempusProject\Models\Skills;
use TheTempusProject\Models\Sourcebooks;
use TheTempusProject\Models\Spells;

class Creator extends Controller {
    public function __construct() {
        parent::__construct();
        self::$title = 'D&D Databases - {SITENAME}';
        self::$pageDescription = 'This is for referencing any number of game features in D&D..';
    }
    public function index() {
        Views::view( 'dnd.dndatabase.index' );
    }
    public function classes() {
        $classes = new Classes;
        Views::view( 'dnd.dndatabase.classes.list', $classes );
    }
    public function items() {
        $items = new Items;
        Views::view( 'dnd.dndatabase.items.list', $items );
    }
    public function monsters() {
        $monsters = new Monsters;
        Views::view( 'dnd.dndatabase.monsters.list', $monsters );
    }
    public function races() {
        $races = new Races;
        Views::view( 'dnd.dndatabase.races.list', $races );
    }
    public function skills() {
        $skills = new Skills;
        Views::view( 'dnd.dndatabase.skills.list', $skills );
    }
    public function sourcebooks() {
        $sourcebooks = new Sourcebooks;
        Views::view( 'dnd.dndatabase.sourcebooks.list', $sourcebooks );
    }
    public function spells() {
        $spells = new Spells;
        Views::view( 'dnd.dndatabase.spells.list', $spells );
    }
}
