<?php
/**
 * app/plugins/fileshare/plugin.php
 *
 * This houses all of the main plugin info and functionality.
 *
 * @package TP FileShare
 * @version 3.0
 * @author  Joey Kimsey <Joey@thetempusproject.com>
 * @link    https://TheTempusProject.com
 * @license https://opensource.org/licenses/MIT [MIT LICENSE]
 */
namespace TheTempusProject\Plugins;

use TheTempusProject\TheTempusProject as App;
use TheTempusProject\Classes\Plugin;
use TheTempusProject\Models\Upload;
use TheTempusProject\Houdini\Classes\Components;
use TheTempusProject\Houdini\Classes\Views;

class Fileshare extends Plugin {
    public $pluginName = 'TP FileShare';
    public $configName = 'fileshare';
    public $pluginAuthor = 'JoeyK';
    public $pluginWebsite = 'https://TheTempusProject.com';
    public $modelVersion = '1.0';
    public $pluginVersion = '3.0';
    public $pluginDescription = 'A simple plugin which adds a site wide file-sharing system.';
    public $permissionMatrix = [
        'uploadFiles' => [
            'pretty' => 'Can upload files',
            'default' => false,
        ],
    ];
    private static $loaded = false;
    public function __construct( $load = false ) {
        parent::__construct( $load );
        if ( $this->checkEnabled() && App::$isLoggedIn ) {
            if ( ! self::$loaded ) {
                App::$topNavRightDropdown .= '<li><a href="{ROOT_URL}fileshare/index/"><i class="glyphicon glyphicon-cloud"></i> FileShare</a></li>';
                self::$loaded = true;
            }
        }
    }
}