<?php
/**
 * app/plugins/tablefinder/plugin.php
 *
 * This houses all of the main plugin info and functionality.
 *
 * @package TP TableFinder
 * @version 3.0
 * @author  Joey Kimsey <Joey@thetempusproject.com>
 * @link    https://TheTempusProject.com
 * @license https://opensource.org/licenses/MIT [MIT LICENSE]
 */
namespace TheTempusProject\Plugins;

use TheTempusProject\Classes\Plugin;

class Tablefinder extends Plugin {
    public $pluginName = 'TP TableFinder';
    public $pluginAuthor = 'JoeyK';
    public $pluginWebsite = 'https://TheTempusProject.com';
    public $modelVersion = '1.0';
    public $pluginVersion = '3.0';
    public $pluginDescription = 'A simple plugin which adds a D&D fifth edition character creator.';
    public $configName = 'tablefinder';
    public $configMatrix = [
        'enabled' => [
            'type' => 'radio',
            'pretty' => 'Enable the table finder.',
            'default' => true,
        ],
    ];
    public $permissionMatrix = [
        'useTableFinder' => [
            'pretty' => 'Can use the table finder',
            'default' => true,
        ],
    ];
    public $main_links = [
        [
            'text' => 'Table Finder ',
            'url' => '{ROOT_URL}creator/index',
        ],
    ];
    public $supported_games = [
        'Dungeons and Dragons' => [
            '5e'
        ],
    ];





// Availability needs to be handled through the plugin
    // basically show 4-week calendar after the current week
    // assume everything is unavailable and have people draw green for available
    // uses calendar plugin for calendar management




// I should be able to delete a campaign
// I should be able to update name, description, dmId
// Creates and assigns the calendar automatically











}